package src.BAALL

import akka.actor.ActorDSL._
import akka.actor.{Props, ReceiveTimeout}
import scala.concurrent.duration._
import src.ship._

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 18.01.13
 * Time: 10:55
 */

class OntUpdaterBAALLLight extends ActWithStash with ABoxFormulaParser {
  val baallbedroomlight = context.actorOf(Props(new BAALLLightControl("baallight.xml")), "lamp1")
  val locallight = context.actorOf(Props(new BAALLLightControl("locallight.xml")), "lamp2")
  val kleiderschrankfach1 = context.actorOf(Props(new BAALLLightControl("lampschrank1.xml")), "schrank1")
  val kleiderschrankfach2 = context.actorOf(Props(new BAALLLightControl("lampschrank2.xml")), "schrank2")
  val kleiderschrankfach3 = context.actorOf(Props(new BAALLLightControl("lampschrank3.xml")), "schrank3")
  val kleiderschrankfach4 = context.actorOf(Props(new BAALLLightControl("lampschrank4.xml")), "schrank4")
  var pos = 0
  var stringModes = List("normal")
  var currentMode = "normal"

  def setMode() {
    val len = stringModes.length
    if (pos >= len) pos = 0
    if (pos < len) {
      val newMode = stringModes.apply(pos)
      if (newMode != currentMode)
        List(baallbedroomlight, locallight,
          kleiderschrankfach1, kleiderschrankfach2,
          kleiderschrankfach3, kleiderschrankfach4).map(a => a ! newMode)
      currentMode = newMode
    }
    pos += 1
  }

  def parseGround(s: String): List[ABoxFormula] = parseNonground(s) map (_.ground)

  def parseNonground(s: String): List[ABoxFormula] = {
    parse(aboxformulas, s) match {
      case Success(l, _) => l
      case _ => List()
    }
  }

  val modes: Map[List[ABoxFormula], String] = Map(
    parseGround("time:Day") -> "daytime",
    parseGround("time:Night") -> "nighttime",
    parseGround("situation:Emergency") -> "emergency",
    parseNonground("(wc,nextpos):wcnextposition and (nextpos,status):position_status and wc != status")
      -> "wheelchairstop",
    parseGround("schrankfach1light:Blink") -> "lamp1blink",
    parseGround("schrankfach2light:Blink") -> "lamp2blink",
    parseGround("schrankfach3light:Blink") -> "lamp3blink",
    parseGround("schrankfach4light:Blink") -> "lamp4blink",
    parseGround("schrankfach1light:NoBlink") -> "lamp1normal",
    parseGround("schrankfach2light:NoBlink") -> "lamp2normal",
    parseGround("schrankfach3light:NoBlink") -> "lamp3normal",
    parseGround("schrankfach4light:NoBlink") -> "lamp4normal"
  )
  context.setReceiveTimeout(3000.millisecond)

  override def receive = {
    case ReceiveTimeout => setMode()
    case CurrentOntology(o) =>
      stringModes = List()
      for ((aboxformulas, mode) <- modes) {
        //println("Query "+aboxformulas)
        if (!o.query(aboxformulas).isEmpty) {
          stringModes = mode :: stringModes
        }
      }
      if (stringModes.isEmpty) stringModes = List("normal")
      setMode()
    case _ =>
  }
}
