
package src.navi;

import org.antlr.runtime.ANTLRFileStream;
import org.antlr.runtime.CommonTokenStream;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 6/9/11
 * Time: 11:32 AM
 */
public class MapParserTest extends junit.framework.TestCase {

    public void testParse() throws Exception {
        File f = new File("src/navi/navigation-graph-baall.cfg.new");
        ANTLRFileStream input = new ANTLRFileStream(f.getAbsolutePath());
        MapLexer lex = new MapLexer(input);
        CommonTokenStream tokens = new CommonTokenStream(lex);
        MapParser parser = new MapParser(tokens);
        parser.map();
        PrintWriter pw = new PrintWriter(new FileWriter("src/navi/rg2.svg"));
        pw.write("<?xml version=\"1.0\" standalone=\"no\"?>\n");
        pw.write("<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\"\n");
        pw.write("  \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\"\n>");
        pw.write("<svg width=\"1600\" height=\"860\" version=\"1.1\"");
        pw.write("     viewBox=\"-5260 -1659 10208 5494\"\n");
        pw.write("     xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\">\n");
        pw.write("\"<g transform=\"scale(1,-1)\"\n>");
        pw.write("<image x=\"-7260\" y=\"-4179\" width=\"12008\" height=\"6494\"\n");
        pw.write("xlink:href=\"floorplan.png\">\n");
        pw.write("</image>\n");
        pw.write("</g>\n");
        pw.write(parser.getMap().toSVG());
        pw.write("\n</svg>\n");
        pw.close();
        // parser.getMap().computeSpanningTree();
    }
}
