package src.ship

import scala.Some
import akka.actor.ActorDSL._
import swing._

/**
 * Created with IntelliJ IDEA.
 * User: autexier
 * Date: 25.06.2012
 * Time: 11:22
 * Time: 11:22
 */

class MonitorsPane(textfont: Font) extends ScrollPane {
  def make_table_entry(s: Any, c: Color): ScrollPane = {
    new ScrollPane() {
      viewportView = new TextArea(10, 30) {
        text = s.toString
        font = textfont
        editable = false
        focusable = false
        preferredSize = new Dimension(10, 30)
        lineWrap = true
        verticalScrollBarPolicy = ScrollPane.BarPolicy.AsNeeded
        background = c
      }
      preferredSize = new Dimension(10, 30)
      verticalScrollBarPolicy = ScrollPane.BarPolicy.AsNeeded
      focusable = false
    }
  }

  def update_table_entry(p: ScrollPane, v: Any, c: Color) {
    p.viewportView match {
      case Some(t: TextArea) =>
        t.text_=(v.toString)
        t.font_=(textfont)
        t.background_=(c)
        //t.caret.position_=(t.text.length)
        t.repaint()
        p.repaint()
      case s =>
    }
    //v.toString()
  }

  def make_table(data: Array[Array[Any]], headers: scala.collection.Seq[String]): Table = {
    new Table(data, headers) {
      font = textfont
      peer.getTableHeader.setFont(textfont)
      autoResizeMode = Table.AutoResizeMode.AllColumns
      rowHeight = 14 * textfont.getSize / 12 * 5
      override def rendererComponent(isSelected: Boolean, hasFocus: Boolean, row: Int, column: Int): Component = {
        if (!data(row)(column).isInstanceOf[ScrollPane]) {
          //println("Not scrollpane " + data(row)(column))
          make_table_entry(data(row)(column), java.awt.Color.WHITE)
        }
        else data(row)(column).asInstanceOf[ScrollPane]
      }
    }
  }

  var data = Array.tabulate[Any](0, 2)((_, _) =>
    make_table_entry(SHIPMonitorStatus(FOLTL.False, "", FOLTL.False, FOLTL.False,
      FOLTL.False, FOLTL.False, FOLTL.False).toString, java.awt.Color.WHITE))
  val headers = scala.collection.Seq("Monitor", "Progress")
  var table = make_table(data, headers)
  //autoResizeMode = Table.AutoResizeMode.AllColumns
  viewportView = table
  repaint()
  var programrow = Map.empty[FOLTL[Concept, ABoxFormula], Int]

  def updateTable(p: FOLTL[Concept, ABoxFormula], status: SHIPMonitorStatus) {
    val color = status.phi match {
      case True => java.awt.Color.GREEN
      case Not(True) => java.awt.Color.RED
      case _ => java.awt.Color.YELLOW
    }
    if (programrow.contains(p)) {
      val guidesc = if (status.desc.isEmpty) p else status.desc
      update_table_entry(data(programrow.get(p).get)(0).asInstanceOf[ScrollPane], guidesc, color)
      update_table_entry(data(programrow.get(p).get)(1).asInstanceOf[ScrollPane], status, color)
      repaint()
      //table.update(programrow.get(p).get, 1, status)
    } else {
      //println("Extending table")
      data = Array.tabulate(table.rowCount + 1, 2)((x, y) => {
        //println("x = "+x+" y = "+y)
        if (x == table.rowCount) {
          if (y == 0) {
            //println("Status "+p+": '"+status.desc+"'")
            if (status.desc.isEmpty) make_table_entry(p, color)
            else make_table_entry(status.desc, color)
          } else make_table_entry(status, color)
        }
        else data(x)(y)
      })
      table = make_table(data, headers)
      programrow = programrow updated(p, table.rowCount - 1)
      viewportView = table
      repaint()
    }
  }

  def findFormulaForRow(row: Int): Option[FOLTL[Concept, ABoxFormula]] = {
    val it = programrow.keysIterator
    var result: Option[FOLTL[Concept, ABoxFormula]] = None
    while (it.hasNext && result == None) {
      val phi = it.next()
      if (programrow.get(phi).get == row) result = Some(phi)
    }
    result
  }

  def removeTableEntry(p: FOLTL[Concept, ABoxFormula]) {
    //println("Removing monitor " + p)
    if (programrow.contains(p)) {
      if (programrow.keySet.size == 1) {
        resetTable(List.empty)
      }
      else {
        var newprogramrow = Map.empty[FOLTL[Concept, ABoxFormula], Int]
        val row = programrow.get(p).get
        data = Array.tabulate(table.rowCount - 1, 2)((x, y) => {
          //println("x = " + x + " y = " + y)
          //println("keyset = "+programrow.keySet)
          //println("values = "+programrow.values)
          if (x < row) {
            if (y == 1) newprogramrow = newprogramrow.updated(findFormulaForRow(x).get, x)
            data(x)(y)
          } else {
            //println("find formula "+(x+1)+" "+findFormulaForRow(x + 1))
            if (y == 1) newprogramrow = newprogramrow.updated(findFormulaForRow(x + 1).get, x)
            data(x + 1)(y)
          }
        })
        programrow = newprogramrow
        table = make_table(data, headers)
        viewportView = table
        repaint()
      }
    }
  }

  def resetTable(ml: List[FOLTL[Concept, ABoxFormula]]) {
    if (ml.isEmpty) {
      data = Array.tabulate[Any](0, 2)((_, _) => make_table_entry(SHIPMonitorStatus(FOLTL.False, "", FOLTL.False, FOLTL.False,
        FOLTL.False, FOLTL.False, FOLTL.False).toString, java.awt.Color.WHITE))
      table = make_table(data, headers)
      viewportView = table
      programrow = Map.empty[FOLTL[Concept, ABoxFormula], Int]
    } else {
      var newprogramrow = Map.empty[FOLTL[Concept, ABoxFormula], Int]
      var newdata = Array.tabulate[Any](table.rowCount - ml.length, 2)((_, _) =>
        make_table_entry(SHIPMonitorStatus(FOLTL.False, "", FOLTL.False, FOLTL.False,
          FOLTL.False, FOLTL.False, FOLTL.False).toString, java.awt.Color.WHITE))
      var newrow = 0
      0 until table.rowCount - 1 map (x => {
        ml find (p => programrow.get(p) == Some(x)) match {
          case None => {}
          case Some(p) => {
            newprogramrow = newprogramrow updated(p, newrow)
            table.update(newrow, 0, data(x)(0))
            table.update(newrow, 1, data(x)(1))
            newrow = newrow + 1
          }
        }
      })
      data = newdata
      programrow = newprogramrow
      table = make_table(data, headers)
      viewportView = table
    }
  }
}

class SHIPGUIMonitors(mp: MonitorsPane) extends ActWithStash {
  var deletionschedule: List[FOLTL[Concept, ABoxFormula]] = List.empty[FOLTL[Concept, ABoxFormula]]
  var newdeletionschedule: List[FOLTL[Concept, ABoxFormula]] = List.empty[FOLTL[Concept, ABoxFormula]]
  val handleDeletions = () => {
    for (phi <- deletionschedule) {
      //println("Removing monitor for " + phi)
      mp.removeTableEntry(phi)
    }
    deletionschedule = newdeletionschedule
    newdeletionschedule = List.empty
    //println("Deletionschedule = " + deletionschedule)
  }

  override def receive = {
    case MonitorFailure(phi, desc, last, current, currentresult) =>
      mp.updateTable(phi, SHIPMonitorStatus(FOLTL.False, desc, last, current, currentresult, FOLTL.False, FOLTL.False))
      newdeletionschedule = phi :: newdeletionschedule
      handleDeletions()
    case MonitorSuccess(phi, state, desc) =>
      mp.updateTable(phi, SHIPMonitorStatus(True, desc, True, True, True, True, True))
      newdeletionschedule = phi :: newdeletionschedule
      handleDeletions()
    case MonitorStopAndStartProgram(phi, prog, desc) =>
      mp.updateTable(phi, SHIPMonitorStatus(RunProg(prog), desc, True, True, True, True, True))
      newdeletionschedule = phi :: newdeletionschedule
      handleDeletions()
    case v@MonitorProgress(phi, state, desc) =>
      //println("GUI monitors got "+v)
      mp.updateTable(phi, SHIPMonitorStatus(state, desc, True, True, True, True, True))
      //if (state==True() || state==Not(True())) newdeletionschedule = phi :: newdeletionschedule
      handleDeletions()
    case ResetMonitors(ml) => mp.resetTable(Nil)
    case MonitorsReset(ml) => mp.resetTable(Nil)
    case _ =>
  }
}
