package src.ship

import akka.actor.ActorDSL._

/**
 * Created with IntelliJ IDEA.
 * User: autexier
 * Date: 3.09.2012
 * Time: 12:43

 */
trait SHIPToolClient extends ActWithStash with ABoxFormulaParser {

  type EXTERNALCLIENT = (Ontology, List[Substitution]) => Option[Pair[List[ABoxFormula], List[Const]]]

  var trigger: Map[List[ABoxFormula], EXTERNALCLIENT] =
    Map.empty

  def ontcase(pre: String, f: EXTERNALCLIENT) {
    trigger = trigger.updated(parseABoxs(pre), f)
  }

  def some[A, B](i: Iterable[A], fil: A => Option[B]): Option[B] = {
    var res: Option[B] = None
    val it = i.iterator
    while (it.hasNext && res == None) {
      val n = it.next()
      //println("Iterating over "+n)
      fil.apply(n) match {
        case v@Some(_) => res = v
        case v => v
      }
    }
    res
  }

  override def receive = {
    case CurrentOntology(ont: Ontology) =>
      println("Client got input, trigger# = " + trigger.size)
      val substfunction: Option[Pair[List[Substitution], EXTERNALCLIENT]] =
        some(trigger, (p: Pair[List[ABoxFormula], EXTERNALCLIENT]) => {
          val pre: List[ABoxFormula] = p._1
          val f: EXTERNALCLIENT = p._2
          //println("Querying with "+pre)
          ont.query(pre) match {
            case v@_ :: _ => Some(Pair(v, f))
            case _ => None
          }
        })
      println("substfunction " + substfunction)
      substfunction match {
        case Some(Pair(substs, clientfu)) =>
          clientfu.apply(ont, substs) match {
            case Some(Pair(aboxformulas, deleteind)) => SHIPTool.ref ! Update(aboxformulas, deleteind)
            case None => println("Nothing computed for substitutions " + substs)
          }
        case None => println("nothing to be served")
      }
    case x => println("routemanager got input " + x)
  }
}

