package src.ship.external

import collection.mutable
import src.ship._

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/30/12
 * Time: 10:03 AM
 * This class contains functions that map ontology objects to scala objects
 */

object Ontology2Scala {

  /**
   * computes a pair representation for the given role
   */
  def RoleEntriesAsList(ont: Ontology, role: Role): List[(String, String)] = {
    var map = List[(String, String)]()
    for (subst <- ont.query(RoleAssertion(Var("x"), Var("y"), role))) {
      map = (subst.apply(Var("x")).name, subst.apply(Var("y")).name) :: map
    }
    map.toList
  }

  def RoleEntryAsList(ont: Ontology, hd: Role, tl: Role, start: String): List[String] = {
    var map = mutable.MutableList[String]()

    var current: Option[Const] = Some(Const(start))
    while (current.isDefined) {
      ont.query(RoleAssertion(current.get, Var("n"), hd)) match {
        case s :: substs => val next = s.apply(Var("n"))
          map.++=(List(next.name))
        case v => v
      }
      ont.query(RoleAssertion(current.get, Var("y"), tl)) match {
        case s :: substs => val next = s.apply(Var("y"))
          current = Some(next.asInstanceOf[Const])
        case Nil => current = None
      }
    }
    map.toList
  }

}
