package src.test

import com.clarkparsia.pellet.owlapiv3.PelletReasonerFactory
import java.io.{File, FileReader}
import org.semanticweb.owlapi.apibinding.OWLManager
import org.semanticweb.owlapi.model.OWLOntologyManager
import org.semanticweb.owlapi.reasoner.OWLReasoner
import src.ship._

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 17.09.12
 * Time: 16:10
 */
class SparqlTestWC {
}

object Test5 extends OntologyParser {
  def main(args: Array[String]) {
    val manager: OWLOntologyManager = OWLManager.createOWLOntologyManager()
    val pm = Builtin.prefixManager
    parseAll(ontology, new FileReader(new File("examples/baall/transport6.ont"))) match {
      case Success(ont, _) =>
        var owlont = Ontology2OWL.convert(ont, pm, manager)
        val factory = new PelletReasonerFactory()
        val reasoner: OWLReasoner = factory.createReasoner(owlont)

        val wcroute = OWLQuery.execQuery("SELECT ?wc ?r WHERE {  Type(?wc,ship:WheelChair), Type(?r,ship:Route), PropertyValue(?wc,ship:wheelchair_route,?r)}",
          ont.getManager, ont.getReasoner, "ship", Builtin.namespace)
        val wcs = OWLQuery.execQuery("SELECT ?wc ?pos WHERE {  Type(?wc,ship:WCAvailable), PropertyValue(?wc,ship:at,?pos)}",
          ont.getManager, ont.getReasoner, "ship", Builtin.namespace)
        val schedules = OWLQuery.execQuery("SELECT ?s WHERE {  Type(?s,ship:WCSchedule)}", ont.getManager, ont.getReasoner, "ship", Builtin.namespace)
        println(schedules map ((s: Substitution) => s.apply(Var("s"))))
        println(wcs)
        println(wcroute)
        println(schedules)
      case NoSuccess(msg, _) => println("parse failure: " + msg)
    }
  }
}
